#include "nustatymai.h"

Nustatymai::Nustatymai() {
  nustatytiRyskuma(ryskumas);
  delay(100);
  nuskaitytiNustatymus();
}

void Nustatymai::begin(LCD_I2C *lcdd, DS1307RTC *rtcc, Buttons *buttonss) {
  lcd = lcdd;
  rtc = rtcc;
  buttons = buttonss;
  preferences = new Preferences;
}

bool Nustatymai::rodytiMeniu() {
  // Serial.println("Esu settingsItem.rodytiMeniu!");
  lcd->setCursor(0, 0);
  delay(20);
  printSpaces(3, lcd);
  Serial.println(preferences->begin("nustatymai", false));
  if (this->menuItem == -1) {

    this->menuItemHighlighted += buttons->checkIfMenuItemChanged();

    lcd->setCursor(3, 0);
    lcd->print("* Nustatymai *");
    this->menuItemHighlighted = this->menuItemHighlighted % this->menuItemMax;
    if (this->menuItemHighlighted < 0)
      this->menuItemHighlighted = 5;

    else if (this->menuItemHighlighted > 5)
      this->menuItemHighlighted = 0;

    else {

      if (this->menuItemHighlighted == 0) {

        lcd->setCursor(0, 1);
        lcd->print("1|Ryskumas   ");
        float ryskumasFloat = ryskumas / 2.55;

        lcd->print(int8_t(ryskumasFloat));
        if (ryskumasFloat < 100) {
          lcd->print(' ');
        }
        if (ryskumas < 10) {
          lcd->print(' ');
        }
        lcd->print('%');
        progressBar(ryskumasFloat, 2, lcd);
      }
      if (this->menuItemHighlighted == 1) {
        lcd->setCursor(0, 1);
        lcd->print("2|Nustatyti laika");
        time_t t;

        t = rtc->get();
        lcd->setCursor(1, 2);
        lcd->print(year(t));
        lcd->print('-');
        if (month(t) < 10)
          lcd->print('0');
        lcd->print(month(t));
        lcd->print('-');
        if (day(t) < 10)
          lcd->print('0');
        lcd->print(day(t));
        lcd->print(' ');

        if (hour(t) < 10)
          lcd->print('0');
        lcd->print(hour(t));
        lcd->print(':');
        if (minute(t) < 10)
          lcd->print('0');
        lcd->print(minute(t));
        lcd->print(':');
        if (second(t) < 10)
          lcd->print('0');
        lcd->print(second(t));
      }
      if (this->menuItemHighlighted == 2) {
        lcd->setCursor(0, 1);
        lcd->print("3|Nustatyti PINs");
        lcd->setCursor(0, 2);
        lcd->print("laistymoPIN[0]=");
        lcd->print(ryskumoPin);

        lcd->setCursor(0, 3);
        lcd->print("");
      }
      if (this->menuItemHighlighted == 4) {
        lcd->setCursor(0, 1);
        lcd->print("Grizti atgal");
        printSpaces(5, lcd);
        lcd->setCursor(0, 2);
        lcd->print(" i pagr. meniu");
        printSpaces(7, lcd);
        if (buttons->getButtonState() == 'o') {
          this->menuItemHighlighted = 0;
          this->subMenuItem = 0;
          this->menuItem = -1;
          lcd->clear();
          return 1;
        }
      }
    }
  }
  if (buttons->getButtonState() == 'o' &&
      buttons->getLastButtonState() == '0') {
    this->menuItem = this->menuItemHighlighted;
    lcd->clear();
    irasytiNustatymus();
  }
  if (this->menuItem == 0) {
    nustatytiRyskuma();
  } else if (this->menuItem == 1) {
    nustatytiLaika();
  } else if (this->menuItem == 2) {
    nustatytiRyskumaPagalLaika();
  }

  if (buttons->getButtonState() == 's' &&
      buttons->getLastButtonState() == '0') {
    irasytiNustatymus();
    lcd->clear();
    menuItem = -1;
    menuItemHighlighted = 0;
    return 1;
  }

  else
    return 0;
}

void Nustatymai::nustatytiRyskuma() {
  this->subMenuItem += buttons->checkIfMenuItemChanged();
  if(buttons->getButtonState() == 'o') {
          irasytiNustatymus();

  }
  if (this->subMenuItem < 0)
    this->subMenuItem = 1;
  if (this->subMenuItem > 1)
    this->subMenuItem %= 2;

  if (this->subMenuItem == 0) {
    this->menuDiff = buttons->parameterAdjustHorizontalContinuous();

    lcd->setCursor(3, 0);
    lcd->print("* Nustatymai *");
    lcd->setCursor(0, 1);
    lcd->print("Ryskumo nustatymas:");
    lcd->setCursor(2, 2);
    lcd->print("->");
    lcd->setCursor(17, 2);
    lcd->print("<-");
    lcd->setCursor(5, 3);
    lcd->print(" PIN: ");
    lcd->print(int8_t(ryskumoPin));
    ryskumas += this->menuDiff;
    float ryskumasFloat = ryskumas / 2.55;
    if (ryskumasFloat > 100)
      ryskumasFloat = 100.0;
    else if (ryskumasFloat < 0)
      ryskumasFloat = 0.2;
    analogWrite(ryskumoPin, ryskumas);
    progressBar(ryskumasFloat, 2, lcd);
  }
  if (this->subMenuItem == 1) {
    griztiAtgalINustatymuMeniu();
    if (this->menuItem == -1) {
      lcd->clear();
      irasytiNustatymus();
    }
  }
    preferences->end();

}


void Nustatymai::nustatytiLaika() {
  tmElements_t tm;
  time_t t;
  t = rtc->get();
  tm.Hour = hour(t); // set the RTC time to 06:29:50
  tm.Minute = minute(t);
  tm.Second = second(t);
  tm.Day = day(t);
  tm.Month = month(t);
  tm.Year = (year(t) - 1970); // tmElements_t.Year is the offset from 1970
                              // postInterrupt();
                              // if (buttons->getLastButtonState() == '0') {
  // buttons->parameterAdjustHorizontal();
  //}
  Serial.println("nustatinėju laika!");
  this->subMenuItem += buttons->checkIfMenuItemChanged();

  if (this->subMenuItem < 0)
    this->subMenuItem = 6;
  if (this->subMenuItem > 6)
    this->subMenuItem %= 7;

  if (this->subMenuItem == 0) {
    tm.Hour += buttons->parameterAdjustHorizontal();
    Serial.println("nustatinėju valandas!");
    lcd->home();
    lcd->print(F("1| Valanda:     "));
    lcd->setCursor(0, 1);

    lcd->print("     - ");
    if (tm.Hour < 10)
      lcd->print("0");
    lcd->print(tm.Hour);
    lcd->print(" +     ");
  }
  Alarm.delay(100);

  if (this->subMenuItem == 1) { // ryskumas
    tm.Minute += buttons->parameterAdjustHorizontal();

    if (this->menuItemChanged == 1)
      rtc->write(tm);
    this->menuItemChanged = 0;
    this->menuDiff = 0;

    lcd->home();
    lcd->print("2| Minute:      ");
    lcd->setCursor(0, 1);
    lcd->print("     - ");
    if (tm.Minute < 10)
      lcd->print("0");
    lcd->print(tm.Minute);
    lcd->print(" +     ");
  }
  if (this->subMenuItem == 2) { // ryskumas
    tm.Second += buttons->parameterAdjustHorizontal();

    lcd->home();
    lcd->print("3| Sekunde:     ");
    lcd->setCursor(0, 1);
    lcd->print("     - ");
    if (tm.Second < 10)
      lcd->print("0");
    lcd->print(tm.Second);
    lcd->print(" +     ");
  }
  if (this->subMenuItem == 3) { // ryskumas
    tm.Day += buttons->parameterAdjustHorizontal();

    lcd->home();
    lcd->print("4| Diena:    ");
    lcd->setCursor(0, 1);
    lcd->print("     - ");
    if (tm.Day < 10)
      lcd->print("0");
    lcd->print(tm.Day);
    lcd->print(" +     ");
  }

  if (this->subMenuItem == 4) { // ryskumas
    tm.Month += buttons->parameterAdjustHorizontal();

    lcd->home();
    lcd->print("5| Menuo:       ");
    lcd->setCursor(0, 1);
    lcd->print("     - ");
    if (tm.Month < 10)
      lcd->print("0");
    lcd->print(tm.Month);
    lcd->print(" +     ");
  }

  if (this->subMenuItem == 5) { // ryskumas
    tm.Year += buttons->parameterAdjustHorizontal();

    lcd->home();
    lcd->print("6| Metai:       ");
    lcd->setCursor(0, 1);
    lcd->print("    - ");
    lcd->print(tm.Year + 1970);
    lcd->print(" +    ");
  }
  if (this->subMenuItem == 6) {
    griztiAtgalINustatymuMeniu();
  }
  menuDiff = 0;

  if (tm.Hour != hour(t) || tm.Minute != minute(t) || tm.Second != second(t) ||
      tm.Day != day(t) || tm.Month != month(t) || (tm.Year + 1970) != year(t)) {

    rtc->write(tm);
    Alarm.delay(20);
    t = rtc->get();
    if (year(t) > 2038) {
      tm.Year = 2038 - 1970;
      rtc->write(tm);
    }

    // timeAdjusted = 1;
  }
  // Alarm.delay(100);
}

void Nustatymai::nuskaitytiNustatymus() {
  // if var doesnt exist set to desired values
  preferences->begin("nustatymai", false); //  readOnly=false

  ryskumas = preferences->getInt("ryskumas", 100);
  ryskumoPin = preferences->getInt("ryskumoPin", 13);

  laistymoPin[0] = preferences->getInt("laistymoPin0", 5);
  laistymoPin[1] = preferences->getInt("laistymoPin1", 5);
  laistymoPin[2] = preferences->getInt("laistymoPin2", 5);
  laistymoPin[3] = preferences->getInt("laistymoPin3", 5);

  dregnumoPin[0] = preferences->getInt("dregnumoPin0", 5);
  dregnumoPin[1] = preferences->getInt("dregnumoPin1", 5);
  dregnumoPin[2] = preferences->getInt("dregnumoPin2", 5);
  dregnumoPin[3] = preferences->getInt("dregnumoPin3", 5);

  temperaturosPin[0] = preferences->getInt("tempPin0", 5);
  temperaturosPin[1] = preferences->getInt("tempPin1", 5);
  temperaturosPin[2] = preferences->getInt("tempPin2", 5);
  temperaturosPin[3] = preferences->getInt("tempPin3", 5);
  preferences->end();
}
void Nustatymai::irasytiNustatymus() {
  // EEPROM.update(adresas, value)
  // if (EEPROM.read(0) != ryskumas)
  preferences->begin("nustatymai", false);

  preferences->putInt("ryskumas", ryskumas);
  preferences->putInt("ryskumoPin", ryskumoPin);

  preferences->putInt("laistymoPin0", laistymoPin[0]);
  preferences->putInt("laistymoPin1", laistymoPin[1]);
  preferences->putInt("laistymoPin2", laistymoPin[2]);
  preferences->putInt("laistymoPin3", laistymoPin[3]);

  preferences->putInt("dregnumoPin0", dregnumoPin[0]);
  preferences->putInt("dregnumoPin1", dregnumoPin[1]);
  preferences->putInt("dregnumoPin2", dregnumoPin[2]);
  preferences->putInt("dregnumoPin3", dregnumoPin[3]);

  preferences->putInt("tempPin0", temperaturosPin[0]);
  preferences->putInt("tempPin1", temperaturosPin[1]);
  preferences->putInt("tempPin2", temperaturosPin[2]);
  preferences->putInt("tempPin3", temperaturosPin[3]);
  preferences->end();
}

void Nustatymai::nustatytiRyskumaPagalLaika() {

  Serial.println("nustatinėju laika!");
  this->subMenuItem += buttons->checkIfMenuItemChanged();
  int menuDiff = buttons->parameterAdjustHorizontal();

  if (this->subMenuItem < 0)
    this->subMenuItem = 6;
  if (this->subMenuItem > 6)
    this->subMenuItem %= 7;
  lcd->setCursor(4, 0);
  lcd->print("* Nustatymai *");
  lcd->setCursor(0, 1);
  lcd->print("*Ryskumas pagal laika:");

  if (this->subMenuItem == 0) {
  }
  if (this->subMenuItem == 1) {
    griztiAtgalINustatymuMeniu();
  }
}

void Nustatymai::nustatytiPins() {

  Serial.println("nustatinėju laika!");
  this->subMenuItem += buttons->checkIfMenuItemChanged();
  this->menuDiff = buttons->parameterAdjustHorizontal();

  if (this->subMenuItem < 0)
    this->subMenuItem = 6;
  if (this->subMenuItem > 6)
    this->subMenuItem %= 7;
  lcd->setCursor(4, 0);
  lcd->print("* Nustatymai *");
  lcd->setCursor(0, 1);
  lcd->print("*Nustatyti PINs:");

  if (this->subMenuItem == 0) {
    lcd->setCursor(0, 2);
  }
  if (this->subMenuItem == 1) { // ryskumas
  }
  if (this->subMenuItem == 2) { // ryskumas
  }
  if (this->subMenuItem == 3) { // ryskumas
  }
  if (this->subMenuItem == 4) { // ryskumas
  }
  if (this->subMenuItem == 5) { // ryskumas
    // 5
  }
  if (this->subMenuItem == 6) {
    griztiAtgalINustatymuMeniu();
  }
}
void Nustatymai::griztiAtgalINustatymuMeniu() {
  lcd->setCursor(0, 0);
  lcd->print("Grizti atgal");
  printSpaces(5, lcd);
  lcd->setCursor(0, 1);
  lcd->print(" i nustatymus");
  printSpaces(7, lcd);
  if (buttons->getButtonState() == 'o') {
    lcd->clear();
    this->subMenuItem = 0;
    this->menuItem = -1;
  }
}

void Nustatymai::nustatytiRyskuma(uint8_t val) {
  pinMode(ryskumoPin, OUTPUT);
  analogWrite(ryskumoPin, val);
  Serial.print("Ryskumas(pin");
  Serial.print(ryskumoPin);
  Serial.print("): ");
  Serial.println(ryskumas);
}
