#include "../include/global.cpp"

#include "../lib/apzvalga.cpp"
#include "../lib/augalas.cpp"
#include "../lib/buttons.cpp"
#include "../lib/nustatymai.cpp"
#include "bootAnimation.cpp"
#include "lcdCharSimplification.h"

LCD_I2C lcd(0x27, 20, 4);
int8_t brightnessPin = 13;

// BluetoothSerial SerialBT;
Buttons buttons;
Nustatymai nustatymai;
DS1307RTC rtc;
Augalas augalas[4];
//Preferences preferences;
bool goBack = 0;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  buttons.begin(&lcd);
  lcd.begin();
  lcd.clear();
  lcd.backlight();
  nustatymai.begin(&lcd, &rtc, &buttons);
  // SerialBT.begin("ESP32");

  // pinMode(13, OUTPUT); // brightnessPin

  //pinMode(35, INPUT);
  nustatymai.nustatytiRyskuma(100);

  // relės išjungimas
  
  pinMode(15, OUTPUT);
  pinMode(2, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);

  digitalWrite(15, 1);
  digitalWrite(2, 1);
  digitalWrite(4, 1);
  digitalWrite(5, 1);

  bootAnimation(&lcd);
  lcd.clear();
  lcd.backlight();
}

void loop() {
  lcd.setCursor(0, 0);
  buttons.read();
  
  if (goBack) {
    menuHighlight = mainMenu;
    mainMenu = -1;
    goBack = 0;
  }
  if (mainMenu == -1) {

    menuHighlight += buttons.checkIfMenuItemChanged();
    if (menuHighlight < 0) {
      menuHighlight = menuMax + 1;
    }
    if (menuHighlight > menuMax) {
      menuHighlight %= (menuMax + 1);
    }
    if (menuHighlight == 0) {
      lcd.print("1| Apzvalga");
      printSpaces(9, &lcd);
    }
    if (menuHighlight == 1) {
      lcd.print("2| Laistymas");
      printSpaces(8, &lcd);
    }
    if (menuHighlight == 2) {
      lcd.print("3| Tuscia");
      printSpaces(11, &lcd);
    }
    if (menuHighlight == 3) {
      lcd.print("4| Tuscia");
      printSpaces(11, &lcd);
    }
    if (menuHighlight == 4) {
      lcd.print("5| Tuscia");
      printSpaces(11, &lcd);
    }
    if (menuHighlight == 5) {
      lcd.print("6| Nustatymai");
      printSpaces(8, &lcd);
    }
    if (buttons.getButtonState() == 'o' &&
        buttons.getLastButtonState() != '0' && mainMenu == -1) {
      mainMenu = menuHighlight;
    }
  } else {
    if (mainMenu == 0) {
      mainMenu = -1;
    }
    if (mainMenu == 1) {
      mainMenu = -1;
    }
    if (mainMenu == 2) {
      mainMenu = -1;
    }
    if (mainMenu == 3) {
      mainMenu = -1;
    }
    if (mainMenu == 4) {
      mainMenu = -1;
    }
    if (mainMenu == 5) {
      if (nustatymai.rodytiMeniu()) {
        mainMenu = -1;
      }
    }
  }
}